/******************************************************************************/
/* PTimer header file.                                                        */
/******************************************************************************/
/* This is part of the PolyKit library.                                       */
/* Copyright (C) 1998-1999 by Polycode.                                       */
/* All rights reserved.                                                       */
/*                                                                            */
/* This source, or parts thereof, may be used for free in free- and shareware */
/* programs. For commercial programs, you have to pay a fee to use it. See    */
/* the license file for more information.                                     */
/******************************************************************************/


#ifndef __PTimer_h
#define __PTimer_h

// PolyKit headers
#include "POS.h"
#include "PSynchronize.h"
#include "PThread.h"
#include "ImportExport.h"


/******************************************************************************/
/* The message that will be sent                                              */
/******************************************************************************/
#if __p_os == __p_beos

#define PM_TIMER			'Ptim'

#elif __p_os == __p_windows

#define PM_TIMER			WM_TIMER

#endif



/******************************************************************************/
/* PTimer class                                                               */
/******************************************************************************/
#if __p_os == __p_beos && __POWERPC__
#pragma export on
#endif

class _IMPEXP_PKLIB PTimer
{
public:
#if __p_os == __p_beos

	PTimer(BLooper *looper, uint16 id);

#elif __p_os == __p_windows

	PTimer(HWND window, uint16 id);

#endif

	virtual ~PTimer(void);

	void SetElapseValue(uint32 value);
	void StartTimer(void);
	void StopTimer(void);

protected:
#if __p_os == __p_beos

	static int32 ThreadFunc(void *object);

	BLooper *sendLooper;
	PSemaphore *runSem;
	PSemaphore *timeoutSem;
	PThread *thread;
	bool paused;

#elif __p_os == __p_windows

	HWND windowHandle;

#endif

	uint16 sendId;
	uint32 waitTime;
	bool running;
};

#if __p_os == __p_beos && __POWERPC__
#pragma export off
#endif

#endif
